#ifndef __BRKTREE_REG_H__
#define __BRKTREE_REG_H__
#ifndef PCI_LATENCY_TIMER
#define	PCI_LATENCY_TIMER	0x0c
#endif
#include "ioctl_twinhan.h"
#define	BROOKTREE_848_ID	0x0350109E
typedef volatile u_int 	bregister_t;
#define	BTBYTE(what)	bregister_t  what:8; int :24
#define	BTWORD(what)	bregister_t  what:16; int: 16
#define BTLONG(what)	bregister_t  what:32
typedef struct _PROGRAM_VALUE
{
	unsigned long frequency;
	unsigned long symbolRate;
	unsigned long h_V;
	unsigned long vPID;
	unsigned long aPID;
	unsigned long i_Q;
	char programName[30];
	struct _PROGRAM_VALUE *Next;
        struct _PROGRAM_VALUE *prev;
} PROGRAM_VALUE, *P_PROGRAM_VALUE;
typedef struct
{
	unsigned char address;
	unsigned char frequencyMSB;
	unsigned char frequencyLSB;
	unsigned char tunerStep;
	unsigned char symbolRateHSB;
	unsigned char symbolRateMSB;
	unsigned char symbolRateLSB;
	unsigned char flag;
	unsigned char checkSum;
}	TUNER_DATA, *P_TUNER_DATA ;
typedef struct _NEW_TUNER_DATA
{
        unsigned char length;
        unsigned char data_tag;
        unsigned char frequencyMSB;
        unsigned char frequencyLSB;
        unsigned char tunerStep;
        unsigned char symbolRateHSB;
        unsigned char symbolRateMSB;
        unsigned char symbolRateLSB;
        unsigned char flag;
        unsigned char checksum;
} NEW_TUNER_DATA, *P_NEW_TUNER_DATA;
struct bt848_registers {
 BTBYTE (dstatus);
#define BT848_DSTATUS_PRES		(1<<7)
#define BT848_DSTATUS_HLOC		(1<<6)
#define BT848_DSTATUS_FIELD		(1<<5)
#define BT848_DSTATUS_NUML		(1<<4)
#define BT848_DSTATUS_CSEL		(1<<3)
#define BT848_DSTATUS_LOF		(1<<1)
#define BT848_DSTATUS_COF		(1<<0)
    BTBYTE (iform);
#define BT848_IFORM_MUXSEL		(0x3<<5)
# define BT848_IFORM_M_MUX1		(0x03<<5)
# define BT848_IFORM_M_MUX0		(0x02<<5)
# define BT848_IFORM_M_MUX2		(0x01<<5)
# define BT848_IFORM_M_RSVD		(0x00<<5)
#define BT848_IFORM_XTSEL		(0x3<<3)
# define BT848_IFORM_X_AUTO		(0x03<<3)
# define BT848_IFORM_X_XT1		(0x02<<3)
# define BT848_IFORM_X_XT0		(0x01<<3)
# define BT848_IFORM_X_RSVD		(0x00<<3)
#define BT848_IFORM_FORMAT		(0x7<<0)
# define BT848_IFORM_F_RSVD		(0x7)
# define BT848_IFORM_F_SECAM		(0x6)
# define BT848_IFORM_F_PALN		(0x5)
# define BT848_IFORM_F_PALM		(0x4)
# define BT848_IFORM_F_PALBDGHI		(0x3)
# define BT848_IFORM_F_NTSCJ		(0x2)
# define BT848_IFORM_F_NTSCM		(0x1)
# define BT848_IFORM_F_AUTO		(0x0)
    BTBYTE (tdec);
    BTBYTE (e_crop);
    BTBYTE (e_vdelay_lo);
    BTBYTE (e_vactive_lo);
    BTBYTE (e_delay_lo);
    BTBYTE (e_hactive_lo);
    BTBYTE (e_hscale_hi);
    BTBYTE (e_hscale_lo);
    BTBYTE (bright);
    BTBYTE (e_control);
#define BT848_E_CONTROL_LNOTCH		(1<<7)
#define BT848_E_CONTROL_COMP		(1<<6)
#define BT848_E_CONTROL_LDEC		(1<<5)
#define BT848_E_CONTROL_CBSENSE		(1<<4)
#define BT848_E_CONTROL_RSVD		(1<<3)
#define BT848_E_CONTROL_CON_MSB		(1<<2)
#define BT848_E_CONTROL_SAT_U_MSB	(1<<1)
#define BT848_E_CONTROL_SAT_V_MSB	(1<<0)
    BTBYTE (contrast_lo);
    BTBYTE (sat_u_lo);
    BTBYTE (sat_v_lo);
    BTBYTE (hue);
    BTBYTE (e_scloop);
#define BT848_E_SCLOOP_RSVD1		(1<<7)
#define BT848_E_SCLOOP_CAGC		(1<<6)
#define BT848_E_SCLOOP_CKILL		(1<<5)
#define BT848_E_SCLOOP_HFILT		(0x3<<3)
# define BT848_E_SCLOOP_HFILT_ICON	(0x3<<3)
# define BT848_E_SCLOOP_HFILT_QCIF	(0x2<<3)
# define BT848_E_SCLOOP_HFILT_CIF	(0x1<<3)
# define BT848_E_SCLOOP_HFILT_AUTO	(0x0<<3)
#define BT848_E_SCLOOP_RSVD0		(0x7<<0)
    int		:32;
    BTBYTE (oform);
    BTBYTE (e_vscale_hi);
    BTBYTE (e_vscale_lo);
    BTBYTE (test);
    int		:32;
    int		:32;
    BTLONG (adelay);
    BTBYTE (bdelay);
    BTBYTE (adc);
#define BT848_ADC_RESERVED		(0x80)
#define BT848_ADC_SYNC_T		(1<<5)
#define BT848_ADC_AGC_EN		(1<<4)
#define BT848_ADC_CLK_SLEEP		(1<<3)
#define BT848_ADC_Y_SLEEP		(1<<2)
#define BT848_ADC_C_SLEEP		(1<<1)
#define BT848_ADC_CRUSH			(1<<0)
    BTBYTE (e_vtc);
    int		:32;
    int 	:32;
    int		:32;
    BTLONG (sreset);
    u_char 	filler[0x8c-0x80];
    BTBYTE (o_crop);
    BTBYTE (o_vdelay_lo);
    BTBYTE (o_vactive_lo);
    BTBYTE (o_delay_lo);
    BTBYTE (o_hactive_lo);
    BTBYTE (o_hscale_hi);
    BTBYTE (o_hscale_lo);
    int		:32;
    BTBYTE (o_control);
#define BT848_O_CONTROL_LNOTCH		(1<<7)
#define BT848_O_CONTROL_COMP		(1<<6)
#define BT848_O_CONTROL_LDEC		(1<<5)
#define BT848_O_CONTROL_CBSENSE		(1<<4)
#define BT848_O_CONTROL_RSVD		(1<<3)
#define BT848_O_CONTROL_CON_MSB		(1<<2)
#define BT848_O_CONTROL_SAT_U_MSB	(1<<1)
#define BT848_O_CONTROL_SAT_V_MSB	(1<<0)
    u_char	fillter1[16];
    BTBYTE (o_scloop);
#define BT848_O_SCLOOP_RSVD1		(1<<7)
#define BT848_O_SCLOOP_CAGC		(1<<6)
#define BT848_O_SCLOOP_CKILL		(1<<5)
#define BT848_O_SCLOOP_HFILT		(0x3<<3)
# define BT848_O_SCLOOP_HFILT_ICON	(0x3<<3)
# define BT848_O_SCLOOP_HFILT_QCIF	(0x2<<3)
# define BT848_O_SCLOOP_HFILT_CIF	(0x1<<3)
# define BT848_O_SCLOOP_HFILT_AUTO	(0x0<<3)
#define BT848_O_SCLOOP_RSVD0		(0x7<<0)
    int		:32;
    int		:32;
    BTBYTE (o_vscale_hi);
    BTBYTE (o_vscale_lo);
    BTBYTE (color_fmt);
#define BT848_COLOR_FMT_ODD_MASK	0xf0
#define BT848_COLOR_FMT_EVEN_MASK	0x0f
#define BT848_COLOR_FMT_RBG32		0x00
#define BT848_COLOR_FMT_RBG24		0x11
#define BT848_COLOR_FMT_RBG16		0x22
#define BT848_COLOR_FMT_RBG15		0x33
#define BT848_COLOR_FMT_YUY2_422	0x44
#define BT848_COLOR_FMT_BTYUV_411	0x55
#define BT848_COLOR_FMT_Y8		0x66
#define BT848_COLOR_FMT_RBG8		0x77
#define BT848_COLOR_FMT_YCRCB_422_PLANAR 0x88
#define BT848_COLOR_FMT_YCRCB_411_PLANAR 0x99
#define BT848_COLOR_FMT_RAW		0xee
    bregister_t color_ctl_swap		:4;
#define BT848_COLOR_CTL_WSWAP_ODD	(1<<3)
#define BT848_COLOR_CTL_WSWAP_EVEN	(1<<2)
#define BT848_COLOR_CTL_BSWAP_ODD	(1<<1)
#define BT848_COLOR_CTL_BSWAP_EVEN	(1<<0)
    bregister_t color_ctl_gamma		:1;
    bregister_t color_ctl_rgb_ded	:1;
    bregister_t color_ctl_color_bars	:1;
    bregister_t color_ctl_ext_frmrate	:1;
    int		:24;
    BTBYTE (cap_ctl);
#define BT848_CAP_CTL_DITH_FRAME	(1<<4)
#define BT848_CAP_CTL_VBI_ODD		(1<<3)
#define BT848_CAP_CTL_VBI_EVEN		(1<<2)
#define BT848_CAP_CTL_ODD		(1<<1)
#define BT848_CAP_CTL_EVEN		(1<<0)
    BTBYTE (vbi_pack_size);
    BTBYTE (vbi_pack_del);
    int		:32;
    BTBYTE (o_vtc);
    u_char	filler2[0x100-0xf0];
    BTLONG (int_stat);
    BTLONG (int_mask);
#define BT848_INT_RISCS			(0xf<<28)
#define BT848_INT_RISC_EN		(1<<27)
#define BT848_INT_RACK			(1<<25)
#define BT848_INT_FIELD			(1<<24)
#define BT848_INT_MYSTERYBIT		(1<<23)
#define BT848_INT_SCERR			(1<<19)
#define BT848_INT_OCERR			(1<<18)
#define BT848_INT_PABORT		(1<<17)
#define BT848_INT_RIPERR		(1<<16)
#define BT848_INT_PPERR			(1<<15)
#define BT848_INT_FDSR			(1<<14)
#define BT848_INT_FTRGT			(1<<13)
#define BT848_INT_FBUS			(1<<12)
#define BT848_INT_RISCI			(1<<11)
#define BT848_INT_GPINT			(1<<9)
#define BT848_INT_I2CDONE		(1<<8)
#define BT848_INT_RSV1			(1<<7)
#define BT848_INT_RSV0			(1<<6)
#define BT848_INT_VPRES			(1<<5)
#define BT848_INT_HLOCK			(1<<4)
#define BT848_INT_OFLOW			(1<<3)
#define BT848_INT_HSYNC			(1<<2)
#define BT848_INT_VSYNC			(1<<1)
#define BT848_INT_FMTCHG		(1<<0)
    int		:32;
    BTWORD (gpio_dma_ctl);

#define BT848_DMA_CTL_RISC_EN		(1<<1)
#define BT848_DMA_CTL_FIFO_EN		(1<<0)
    BTLONG (i2c_data_ctl);
#define BT848_DATA_CTL_I2CDIV		(0xf<<4)
#define BT848_DATA_CTL_I2CSYNC		(1<<3)
#define BT848_DATA_CTL_I2CW3B		(1<<2)
#define BT848_DATA_CTL_I2CSCL		(1<<1)
#define BT848_DATA_CTL_I2CSDA		(1<<0)
    BTLONG (risc_strt_add);
    BTLONG (gpio_out_en);
    BTLONG (gpio_reg_inp);
    BTLONG (risc_count);
    u_char	filler3[0x200-0x124];
    BTLONG (gpio_data);
};

struct bt848f1_registers {
    u_char	filler[0x100];
    BTLONG (int_stat);
    BTLONG (int_mask);
    int		:32;
    BTLONG (gpio_dma_ctl);
    BTLONG (audio_packet_length);
#define BT848_AFP_LEN		(0xff<<16)
#define BT848_ALP_LEN		(0xfff<<0)
    BTLONG (risc_strt_add);
    int   :32;
    int   :32;
    BTLONG (risc_count);
};

typedef volatile struct bt848_registers* bt848_ptr_t;
typedef volatile struct bt848f1_registers* bt848f1_ptr_t;

struct bktr_softc {
    bt848_ptr_t base;
    bt848f1_ptr_t f1base;
#if __FreeBSD__
    vm_offset_t phys_base;
    pcici_t 	tag;
#ifdef DEVFS
    void *devfs_token;
#endif
#endif
#ifdef linux
    u_int	phys_base;
    u_char	bus;
    u_char	devfn;
    u_char	irq;
    u_char	revision;
    u_int       f1phys_base;
    u_char	f1bus;
    u_char	f1devfn;
    u_char	f1irq;
    u_char	f1revision;
    struct wait_queue *sleep;
#endif
    vm_offset_t bigbuf;
    int		alloc_pages;
    struct proc	*proc;
    int		signal;
#define	METEOR_SIG_MODE_MASK	0xffff0000
#define	METEOR_SIG_FIELD_MODE	0x00010000
#define	METEOR_SIG_FRAME_MODE	0x00000000
    vm_offset_t  dma_prog;
    char        dma_prog_loaded;
    u_long	fifo_errors;
    u_long	dma_errors;
    unsigned	flags;
#define DST_INITIALIZED	0x00000001
#define DST_CAPTURING	0x00000002
#define DST_PAUSED      0x00000008
 u_char	tflags;
#define	TUNER_INITALIZED 0x00000001
#define	TUNER_OPEN	0x00000002
    LNB_LOF      LNB;
    int    flag22K;
    int    flag1318V;
    PROGRAM_VALUE 	programValue;
    int   line_length;
    char  commandReply[8];
    u_long  rings;
    int card_version; //0: non_CI_Card ,  1:CI_Card
    int TS_Size;
    char card_name[8];
    int card_type;
};
typedef struct bktr_softc bktr_reg_t;
typedef struct bktr_softc* bktr_ptr_t;
#define BT878_DEVCTRL 0x40
#define BT878_EN_TBFX 0x02
#endif
