#ifndef __BT848_COMMON_H__
#define __BT848_COMMON_H__
#ifndef PCI_VENDOR_ID_BROOKTREE
#define PCI_VENDOR_ID_BROOKTREE 0x109e
#define PCI_DEVICE_ID_BT848     0x350
#endif
#ifndef PCI_DEVICE_ID_BT878
#define PCI_DEVICE_ID_BT878     0x36e
#endif
#ifndef PCI_DEVICE_ID_BT879
#define PCI_DEVICE_ID_BT879     0x36f
#endif
#ifndef PCI_DEVICE_ID_BT849
#define PCI_DEVICE_ID_BT849     0x351
#endif
#ifndef PCI_DEVICE_ID_BT878_F1
#define PCI_DEVICE_ID_BT878_F1  0x36e
#endif
#ifndef PCI_DEVICE_ID_BT879_F1
#define PCI_DEVICE_ID_BT879_F1  0x36f
#endif
#define DMA_PROG_ALLOC		(6 * PAGE_SIZE)
#define DMA_BT848_SPLIT 319*2
#ifndef BROOKTREE_ALLOC_PAGES
#define BROOKTREE_ALLOC_PAGES	765
#endif
#define BROOKTREE_ALLOC		(BROOKTREE_ALLOC_PAGES * PAGE_SIZE)
extern bktr_reg_t brooktree[ NBKTR ];
extern int brooktree_cnt;
#define BROOKTRE_NUM(mtr)	((bktr - &brooktree[0])/sizeof(bktr_reg_t))
#if !defined( DEFAULT_CHNLSET )
#define DEFAULT_CHNLSET	CHNLSET_NABCST
#endif
#define BSWAP (BT848_COLOR_CTL_BSWAP_ODD | BT848_COLOR_CTL_BSWAP_EVEN)
#define WSWAP (BT848_COLOR_CTL_WSWAP_ODD | BT848_COLOR_CTL_WSWAP_EVEN)
#define TUNER_AFC
#define TEST_TUNER_AFC_NOT
#if defined( TUNER_AFC )
#define AFC_DELAY		10000
#define AFC_BITS		0x07
#define AFC_FREQ_MINUS_125	0x00
#define AFC_FREQ_MINUS_62	0x01
#define AFC_FREQ_CENTERED	0x02
#define AFC_FREQ_PLUS_62	0x03
#define AFC_FREQ_PLUS_125	0x04
#define AFC_MAX_STEP		(5 * FREQFACTOR)
#endif
#define TEST_PAL
#define MCU_WADDR 0xaa
#define MCU_RADDR 0xab
#define STATUS_SUM
#define FIFO_ENABLED		BT848_DMA_CTL_FIFO_EN
#define RISC_ENABLED		BT848_DMA_CTL_RISC_EN
#define FIFO_RISC_ENABLED	(BT848_DMA_CTL_FIFO_EN | BT848_DMA_CTL_RISC_EN)
#define FIFO_RISC_DISABLED	0
#define ALL_INTS_DISABLED	0
#define ALL_INTS_CLEARED	0xffffffff
#define CAPTURE_OFF		0
#define BIT_SEVEN_HIGH		(1<<7)
#define BIT_EIGHT_HIGH		(1<<8)
#define I2C_BITS		(BT848_INT_RACK | BT848_INT_I2CDONE)
#define DMABUFFERLEN    255*2*4092UL

vm_offset_t 	get_bktr_mem( int unit, unsigned size );
void bktr_intr( void *arg );
void start_capture( bktr_ptr_t bktr );
void dst_close(bktr_ptr_t bktr);
int dst_ioctl( bktr_ptr_t bktr, int unit, int cmd, caddr_t arg, struct proc* pr );
int check_card_version(bktr_ptr_t bktr);
void get_dmaBufferInfo(bktr_ptr_t bktr, P_DMA_BUFFER_INFO dmaBufferInfo);
int Init_Demux(bktr_ptr_t bktr, P_DEMULTIPLEXER_VALUE pRV, int unit);
int dst_set_voltage(bktr_ptr_t bktr, int nVol);
int dst_set_diseqc(bktr_ptr_t bktr, P_DISEQC_VALUE pDV);
int dst_get_signal(bktr_ptr_t bktr, P_SIGNAL_VALUE pSV);
int dst_set_lnb(bktr_ptr_t bktr, P_LNB_INFO pLnbInfo);
int dst_set_diseqc_command(bktr_ptr_t bktr, P_DISEQC_COMMAND pDiscComm);
#endif
