#ifndef __BT848_LINUX_H__
#define __BT848_LINUX_H__

//#define DEBUG

#define MYMSG(string, args...)  //printk(KERN_ERR "DST_MYMSG:" string, ##args)
#ifdef DEBUG
#define DBGMSG(string, args...) printk(KERN_ERR "DST_DBGMSG:" string, ##args)
#define TRYMSG(string, args...) printk(KERN_ERR "DST_RRYMSG:" string, ##args)
#define RETMSG(string, args...) printk(KERN_ERR "DST_RETMSG:" string, ##args)
#define ERRMSG(string, args...) printk(KERN_ERR "DST_ERRMSG:" string, ##args)
#else  //RELEASE
#define DBGMSG(string, args...)
#define TRYMSG(string, args...) printk(KERN_ERR "DST_TRYMSG:" string, ##args)
#define RETMSG(string, args...) printk(KERN_ERR "DST_RETMSG:" string, ##args)
#define ERRMSG(string, args...) printk(KERN_ERR "DST_ERRMSG:" string, ##args)
#endif

#define BT848_VERSION "0.8"

#include <linux/types.h>

#define vm_offset_t volatile char *
#define printf printk
#define bzero(p, s) memset(p, 0, s)
#define disable_intr cli
#define enable_intr sti
#define bool_t int
#define quad_t long long

//#define min(a, b) ((a) < (b) ? (a) : (b))

#ifndef PAGE_SIZE
#include <asm/page.h>
#endif

#define btoc(bytes)	((bytes+(PAGE_SIZE-1)) / PAGE_SIZE)

#define DELAY(usecs)	udelay(usecs)
#include <asm/delay.h>

//#define vtophys virt_to_phys
#define vtophys virt_to_bus //louis
#include <asm/io.h>

#include "dmaBuffer.h"

#endif 
