#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <inttypes.h>
#include "read_demo.h"

#define DEV_NODE "/dev/twinhan0"
int main(int argc, char* argv[])
{    
    int nKSize = 5*1024;
    
    /****************** Init Device *********************/    
    LNB_LOF Lnb_Lof = { 5150, 11300 };       
    LNB_INFO LnbInfo = {1, 0, 0, 0}; //{Power_Enable, K22_Enable, Tone_Burst_Enable, Data_Burst_Enable}
	/*DISEQC_VALUE Diseqc_Val = {1, LNB_TYPE_NORMAL, POLARITY_V}; //nDiseqc_Port, nLnb_Type, nPolarity
	PROGRAM_VALUE ProgramValue = 
	    {3780, 28100, Diseqc_Val.nPolarity, 514, 648, 0,",,,",NULL,NULL};    //AsiaSat3 -> 709 Star News -> nPolarity = POLARITY_V*/    
    DISEQC_VALUE Diseqc_Val = {2, LNB_TYPE_NORMAL, POLARITY_H}; //AsiaSat2S -> DWtv
    PROGRAM_VALUE ProgramValue = 
        {4000, 28125, Diseqc_Val.nPolarity, 2305, 2306, 0,",,,",NULL,NULL};    //AsiaSat2S -> DWtv -> nPolarity = POLARITY_H
			    
    CARD_VALUE cv;
    if (TH_ERROR == Getdevice_CardType(&cv))
	    return TH_ERROR;
	    
	if (TH_ERROR == Setdevice_Init(&Lnb_Lof))
	    return TH_ERROR;
	    
	if (TH_ERROR == Setdevice_LNB(&LnbInfo))
	    return TH_ERROR;
   	    
	if (TH_ERROR == Setdevice_Diseqc(&Diseqc_Val))
	    return TH_ERROR;

	if (TH_ERROR == Lock_Channel(&ProgramValue))
	    return TH_ERROR;
		
	SIGNAL_VALUE Signal_Val = {0, 0, 0};
	if (TH_ERROR == Getdevice_Signal_State(&Signal_Val))
	    return TH_ERROR;

	/************ Get TS stream => Demultiplexing => Save files ***********/		
	DEMULTIPLEXER_VALUE DemultiplexerValue;
	DemultiplexerValue.PID  = ProgramValue.vPID;  //for TH_PID_TS_PACKET, TH_PID_PES_PACKET, TH_ALL_PID_TS_PACKET
	DemultiplexerValue.vPID = ProgramValue.vPID;  //for TH_VA_TS_PACKET
	DemultiplexerValue.aPID = ProgramValue.aPID;  //for TH_VA_TS_PACKET
	DemultiplexerValue.StreamType = TH_PID_PES_PACKET;	
		
	
	if (TH_ERROR == Init_Demux(&DemultiplexerValue))
	    return TH_ERROR;	
    RET_MSG(">>>>>>>>>>>>> Begin to demux...Capture %d K bytes <<<<<<<<<<<<<<\n", nKSize);
    if (TH_ERROR == RecToFile("./sat.dat", nKSize))
        return TH_ERROR;	
    RET_MSG(">>>>>>>>>>>>>>>>>>>>>> Demux Completed <<<<<<<<<<<<<<<<<<<<<<<<<<\n");
	return  TH_NO_ERROR;
}

#define STREAM_BUFFER_SIZE 1024  //1K
int RecToFile(char *sFileName, int nKSize)
{    
    unsigned char pTemp[STREAM_BUFFER_SIZE];
        
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
        ERR_MSG("No device finded!\n");
        return TH_ERROR;
    }  
    
    FILE *fd = fopen(sFileName, "wb");
    if (fd == NULL) {
        ERR_MSG("open %s err!! \n", sFileName);
        return TH_ERROR;
    }
    
    int i;    
    for (i=0; i<nKSize; i++) {
        //memset((void*)pTemp, 0xF0, STREAM_BUFFER_SIZE);
        if (read(nDevHandle, pTemp, STREAM_BUFFER_SIZE) <= 0) {
          ERR_MSG("read() err!! \n");          
          fclose(fd);
          close(STREAM_BUFFER_SIZE);
          return TH_ERROR;
        }
        fwrite(pTemp, STREAM_BUFFER_SIZE, 1, fd);
    }    
    
    fclose(fd);
    close(nDevHandle);  
    return TH_NO_ERROR;
}

int Init_Demux(P_DEMULTIPLEXER_VALUE pDMV)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
        ERR_MSG("No device finded!\n");
        return TH_ERROR;
    }   
    
    if (ioctl(nDevHandle, INIT_DEMUX, pDMV)) {
        ERR_MSG("ioctl READ_ENABLE err !!\n");
        return TH_ERROR;
    }
    
    close(nDevHandle);     
    DBG_MSG("Read_Enable OK !\n");
    return  TH_NO_ERROR;
}
    
int Getdevice_Signal_State(P_SIGNAL_VALUE pSignal_Val)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
        ERR_MSG("No device finded!\n");
        return TH_ERROR;
    }   
    
    if (ioctl(nDevHandle, DST_GET_SIGNAL, pSignal_Val)) {
        ERR_MSG("ioctl DST_GET_SIGNAL failed !\n");
        return TH_ERROR;
    }    
	
    DBG_MSG("Device signal: LockFlag=%d,  strength=%d,  quality=%d\n", 
             pSignal_Val->nLockFlag, pSignal_Val->nDevSigStrength, pSignal_Val->nDevSigQuality);
    close(nDevHandle);  
    return TH_NO_ERROR;
}

int Getdevice_CardType(P_CARD_VALUE pCV)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
        ERR_MSG("No device finded!\n");
        return TH_ERROR;
    }
    
    if (ioctl(nDevHandle, DST_GET_CARD_TYPE, pCV )) {
        ERR_MSG("ioctl DST_GET_CARD_TYPE failed !\n");
        return TH_ERROR;
    }
    
    close(nDevHandle);     
    DBG_MSG("Card Name=%s,  TS_Size=%d !\n", pCV->sCard_Name, pCV->nTS_SIZE);
    return  TH_NO_ERROR;    
}
    
int Setdevice_Init(P_LNB_LOF pLnb_Lof)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
        ERR_MSG("No device finded!\n");
        return TH_ERROR;
    }
    
    if (ioctl(nDevHandle, DST_INIT, pLnb_Lof)) {
        ERR_MSG("ioctl Setdevice_Init failed !\n");
        return TH_ERROR;
    }
    
    close(nDevHandle);     
    DBG_MSG("Setdevice_Init OK !\n");
    return  TH_NO_ERROR;
}

int Setdevice_LNB(P_LNB_INFO pLnbInfo)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
		ERR_MSG("No device finded!\n");
		return TH_ERROR;
	}
	if (ioctl(nDevHandle, DST_SET_LNB, pLnbInfo)) {        
        ERR_MSG("ioctl Setdevice_LNB failed !\n");
        return TH_ERROR;
    }
    
    close(nDevHandle);   
    DBG_MSG("Setdevice_LNB OK !\n");
    return TH_NO_ERROR;
}

int Setdevice_Diseqc(P_DISEQC_VALUE pDiseqc_Val)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
		ERR_MSG("No device finded!\n");
		return TH_ERROR;
	}
	if (ioctl(nDevHandle, DST_SET_DISEQC, pDiseqc_Val)) {        
        ERR_MSG("ioctl DST_SET_DISEQC failed !\n");
        return TH_ERROR;
    }    

    close(nDevHandle);    
    DBG_MSG("Setdevice_Diseqc OK !\n");
    return TH_NO_ERROR;
}

int Lock_Channel(P_PROGRAM_VALUE  pProgramValue)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
		ERR_MSG("No device finded!\n");
		return TH_ERROR;
	}
	
    if(ioctl(nDevHandle, TUNER_SETTUNER, pProgramValue ) ) {
        ERR_MSG("ioctl Set tuner failed !\n");
        return TH_ERROR;
    }
    if (ioctl(nDevHandle, DST_START_CAPTURE, 0 ) ) {
        ERR_MSG("ioctl start capture failed!\n");
        return TH_ERROR;
    }
    
    close(nDevHandle);        
    DBG_MSG("Lock channel OK!\n");
    return TH_NO_ERROR;
}

/*******************************************************************************/
